-- name: [CS] Retro Fratello
-- description: by 6b

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    Use this if you're curious on how anything here works >v<
]]

local E_MODEL_FMARIO = smlua_model_util_get_id("fratellomario_geo")
local E_MODEL_FLUIGI = smlua_model_util_get_id("fratelloluigi_geo")

local TEX_FMARIO_ICON = get_texture_info("fratellomario_logo")
local TEX_FLUIGI_ICON = get_texture_info("fratelloluigi_logo")

local TEXT_MOD_NAME = "[CS] Retro Fratello"

local VOICETABLE_FMARIO = {
    [CHAR_SOUND_ATTACKED] = 'Death 2.ogg',
    [CHAR_SOUND_DOH] = 'Bump.ogg',
    [CHAR_SOUND_DROWNING] = 'Death.ogg',
    [CHAR_SOUND_DYING] = 'Death.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Thwomp.ogg',
    [CHAR_SOUND_HAHA] = 'Transformation.ogg',
    [CHAR_SOUND_HAHA_2] = 'Transformation.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Correct Match Card.ogg',
    [CHAR_SOUND_HOOHOO] = 'Super Mario Jump.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Map Start.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Transformation.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Fire.ogg',
    [CHAR_SOUND_OOOF] = 'Death 2.ogg',
    [CHAR_SOUND_OOOF2] = 'Death 2.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Kick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Fireball.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Fireball.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Bowser Falling.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Item Box.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Bowser Falling.ogg',
    [CHAR_SOUND_WAH2] = 'Kick.ogg',
    [CHAR_SOUND_WHOA] = 'Inventory.ogg',
    [CHAR_SOUND_YAHOO] = 'Frog Mario Jump.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'Frog Mario Jump.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'Super Mario Jump.ogg',
    [CHAR_SOUND_YAWNING] = 'Pause.ogg',
}


if _G.charSelectExists then
    CT_CHAR = _G.charSelect.character_add("[Fratello] Mario", {"Redesign by 6b of Mario & Luigi", "looking a bit like SMB's retro sprites."}, "6b", {r = 255, g = 0, b = 0}, E_MODEL_FMARIO, CT_MARIO, TEX_FMARIO_ICON)
    CT_CHAR = _G.charSelect.character_add("[Fratello] Luigi", {"Redesign by 6b of Mario & Luigi", "looking a bit like SMB's retro sprites."}, "6b", {r = 0, g = 255, b = 0}, E_MODEL_FLUIGI, CT_MARIO, TEX_FLUIGI_ICON)

    -- the following must be hooked for each character added
    _G.charSelect.character_add_voice(E_MODEL_FMARIO, VOICETABLE_FMARIO)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_FMARIO then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_FMARIO then return _G.charSelect.voice.snore(m) end
    end)

        -- the following must be hooked for each character added
        _G.charSelect.character_add_voice(E_MODEL_FLUIGI, VOICETABLE_FMARIO)
        hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_FMARIO then return _G.charSelect.voice.sound(m, sound) end
        end)
        hook_event(HOOK_MARIO_UPDATE, function (m)
            if _G.charSelect.character_get_voice(m) == VOICETABLE_FMARIO then return _G.charSelect.voice.snore(m) end
        end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end